#ifndef IMAGEFILTER_H
#define IMAGEFILTER_H


#include "..\..\common\util_xml.h"
#include "..\..\common\util_defs.h"
#include "imagefiltersettings.h"
#include "..\..\common\nCoreAPI.h"


namespace FilterSpace {

	public ref class ImageFilter : public ImageFilterBase
	{
	public:
		// SUPPORT FUNCTIONS --> Implement them in "ImageFilter.cpp"
		static int     GetAPIVersion(){      return IMAGEFILTER_API_VERSION; }
		static String^ GetFilterName(){      return FILTER_NAME; }
		static String^ GetFilterGroupName(){ return FILTER_GROUP; }
		static int     GetFilterVersion(){   return FILTER_VERSION; }
		static bool    CanLocalize();
		static IntPtr  GetSupportedFormats();
		static IntPtr  CreateFilterSettings(Byte* fs, bool silent);

		static bool    ExecuteFilter(Byte* fs);
		static bool    FilterCore(filtersettings* f, int sx, int sy, int sw, int sh);
	private:
		static filtersettings* XmlToMyStruct(xml_node^ fs, bool creating);
	};
}


#endif
